=== debian/changelog ===
groonga (13.0.9+dfsg-1) unstable; urgency=medium

  * New upstream version 13.0.9+dfsg
  * debian/groonga-tokenizer-mecab.lintian-overrides
    debian/libgroonga0.lintian-overrides
    - Update mismatched-override pattern

 -- Kentaro Hayashi <kenhys@xdump.org>  Wed, 08 Nov 2023 13:33:51 +0900

groonga (13.0.8+dfsg-1) unstable; urgency=medium

  * New upstream version 13.0.8+dfsg
  * debian/patches/fix-ftbfs-hurd.patch
    debian/patches/python3-pydata-sphinx-theme-0.7.2.patch
    - Refresh patch files

 -- Kentaro Hayashi <kenhys@xdump.org>  Sat, 21 Oct 2023 19:30:01 +0900

groonga (13.0.7+dfsg-1) unstable; urgency=medium

  * New upstream version 13.0.7+dfsg
  * debian/control
    - Add missing dependency to libjs-sphinxdoc for groonga-doc
  * debian/patches/avoid-env-ruby.patch
    - Refresh patch file

 -- Kentaro Hayashi <kenhys@xdump.org>  Sun, 17 Sep 2023 20:00:43 +0900

groonga (13.0.5+dfsg-2) unstable; urgency=medium

  * debian/tests/control,status
    - Fixed preventing migration because of dropped groonga-httpd.
  * debian/copyright
    - Cleanup unused entries.

 -- Kentaro Hayashi <kenhys@xdump.org>  Sat, 26 Aug 2023 15:22:34 +0900

groonga (13.0.5+dfsg-1) unstable; urgency=medium

  * New upstream version
  * debian/watch
    - Follow changed upstream.
  * debian/control,debian/copyright
    - Add missing dependency to support markdown.
    - Drop groonga-httpd.
  * debian/clean,debian/rules,debian/source/options
    - Fix FTBFS (double build) (Closes: #1045089)

 -- Kentaro Hayashi <kenhys@xdump.org>  Thu, 17 Aug 2023 20:39:33 +0900
