## groonga 13.1.0

=== debian/changelog ===
groonga (13.1.0-1) unstable; urgency=low

  * New upstream release.

 -- Horimoto Yasuhiro <horimoto@clear-code.com>  Mon, 25 Dec 2023 09:07:19 -0000
