## groonga 13.1.1

=== debian/changelog ===
groonga (13.1.1-1) unstable; urgency=low

  * New upstream release.

 -- Horimoto Yasuhiro <horimoto@clear-code.com>  Tue, 09 Jan 2024 07:56:24 -0000
